String currentStore = "rootStore";

final Map<String, Map<String, dynamic>> store = {currentStore: {}};

void useStore(String storeName) {
  currentStore = storeName;
  if (!store.containsKey(currentStore)) store[currentStore] = {};
}

void saveToStore(String key, value) => store[currentStore][key] = value;

void saveToStoreMultiple(Map<String, dynamic> pairs) {
  pairs.forEach((key, value) {
    saveToStore(key, value);
  });
}

Map<String, dynamic> serveStore([String storeName]) {
  storeName ??= currentStore;
  return store[storeName];
}

// Deletes current store or specified store
Map<String, dynamic> removeStore([String storeName]) {
  storeName ??= currentStore;
  final Map<String, dynamic> r = store.remove(currentStore);
  useStore("rootStore");
  return r;
}

E getFromStore<E>(String key, [defaultvalue]) =>
    (store[currentStore][key] ?? defaultvalue) as E;

List<String> createLogStringList(Map<String, dynamic> store) {
  final List<String> ls = [];
  store.forEach((key, value) {
    ls.add('$key : $value');
  });
  return ls;
}

List<String> pad(List<String> ls, String pad) {
  return ls.map((e) => pad + e).toList();
}

List<String> insertAtEnds(List<String> ls, String begin, String end) {
  ls.insert(0, begin);
  ls.add(end);
  return ls;
}

String listToString(List<String> ls) {
  return ls.reduce((value, element) => value + '\n' + element);
}

void logStore([String storeName]) {
  storeName ??= currentStore;

  final str = listToString(createLogList(storeName, store[storeName]));

  print(str);
}

List<String> createLogList(String storeName, Map<String, dynamic> store) {
  return insertAtEnds(
      pad(createLogStringList(store), '\t'), '*** $storeName', '***');
}

void logCompleteStore() {
  List<String> ls = [];

  store.forEach((key, value) {
    final str =
        listToString((pad(createLogList(key, store[key]), '\t'))..add(''));
    ls.add(str);
  });

  ls.insert(0, '');
  ls = insertAtEnds(ls, '***** Complete Store', '*****');
  print(listToString(ls));
}

main(List<String> args) {
  saveToStore('key', 4);
  saveToStore('key1', 44);
  saveToStore('key2', 444);
  saveToStore('key3', 4444);

  useStore('storeName1');

  saveToStore('key', 4);
  saveToStore('key1', 44);
  saveToStore('key2', 444);
  saveToStore('key3', 4444);

  logCompleteStore();
}
